<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\Sect;
use Exception;
use Illuminate\Database\Eloquent\ModelNotFoundException;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;
use Illuminate\Http\JsonResponse;
use Yajra\DataTables\Facades\DataTables;

class SectController extends Controller
{
    public function index()
    {
        $sects = Sect::orderBy('created_at', 'desc')->get();

        return view('admin.sects.index', compact('sects'));
    }

    public function getSectList(Request $request)
    {
        $sqlBuilder = Sect::select([
            'sects.id',
            'sects.name',
            'sects.name_ar',
            'sects.status',
        ]);

        return DataTables::of($sqlBuilder)
            ->filter(function ($query) use ($request) {
                if ($request->has('search') && !empty($request->search['value'])) {
                    $query->where('sects.name', 'ilike', "%" . $request->search['value'] . "%")
                    ->orWhere('sects.name_ar', 'ilike', "%" . $request->search['value'] . "%");
                }
            })
            ->editColumn('status', function ($data) {
                return '<div class="status">
                <div class="form-check form-switch ">
                    <input class="form-check-input status-checkbox" type="checkbox" role="switch" id="SwitchCheck4" data-url="' . route('admin.sects.status', ['id' => $data->id]) . '" data-id="' . $data->id . '" ' . (!empty($data->status) && $data->status == 1 ? 'checked' : '') . ' />
                </div>
            </div>';
            })
            ->addColumn('action', function ($data) {
                $html = '<div class="dropdown">
                                        <a href="#" class="btn btn-soft-secondary btn-sm" role="button" id="dropdownMenuLink5" data-bs-toggle="dropdown" aria-expanded="false">
                                            <i class="ri-more-2-fill"></i>
                                        </a>
                                        <ul class="dropdown-menu" aria-labelledby="dropdownMenuLink5">
                                            <li><a class="dropdown-item" href="' . route('admin.sects.edit', ['id' => $data->id]) . '">Edit</a></li>
                                            <li><a class="dropdown-item delete-btn" data-url="' . route('admin.sects.destroy', ['id' => $data->id]) . '">Delete</a></li>
                                        </ul>
                                    </div>';
                return $html;
            })
            ->rawColumns(['status', 'action'])
            ->make(true);
    }

    public function create()
    {
        $sect = "";

        return view('admin.sects.create', compact('sect'));
    }

    public function store(Request $request)
    {
        $rules = [
            'name' => 'required|string|max:255',
            'name_ar' => 'required|string|max:255',
            'status' => 'required|in:0,1',
        ];

        $validator = Validator::make($request->all(), $rules);

        if ($validator->fails()) {
            return response()->json([
                'status' => 'error',
                'errors' => $validator->errors(),
            ], 422);
        }

        if ($request->id) {
            $sect = Sect::find($request->id);

            if (!$sect) {
                return response()->json(['status' => 'error', 'message' => 'Sect not found'], 404);
            }

            $sect->name = $request->name;
            $sect->name_ar = $request->name_ar;
            $sect->status = $request->status;
            $sect->save();

            return response()->json(['status' => 'success', 'message' => 'Sect updated successfully']);
        } else {
            $alreadyExists = Sect::where('name', $request->name)->orWhere('name_ar', $request->name_ar)->first();
            if ($alreadyExists) {
                return response()->json(['status' => 'error', 'message' => 'Sect already exists'], 422);
            }
            $sect = Sect::create([
                'name' => $request->name,
                'name_ar' => $request->name_ar,
                'status' => $request->status,
            ]);

            return response()->json(['status' => 'success', 'message' => 'Sect added successfully', 'sect' => $sect]);
        }
    }

    public function edit($id)
    {
        $sect = Sect::findOrFail($id);

        return view('admin.sects.create', compact('sect'));
    }

    public function destroy($id): JsonResponse
    {
        try {
            $sect = Sect::findOrFail($id);
            $sect->delete();
            return response()->json([
                'status' => 'success',
                'message' => 'Sect deleted successfully.'
            ], 200);
        } catch (ModelNotFoundException $e) {
            return response()->json([
                'status' => 'error',
                'message' => 'Sect not found.'
            ], 404);
        } catch (Exception $e) {
            return response()->json([
                'status' => 'error',
                'message' => 'An error occurred while deleting the sect.'
            ], 500);
        }
    }

    public function statusChange(Request $request, $id)
    {
        $sect = Sect::find($id);

        if (!$sect) {
            return response()->json([
                'status' => 'error',
                'message' => 'Sect not found.'
            ], 404);
        }

        $sect->status = $request->status;
        $sect->save();

        return response()->json([
            'status' => 'success',
            'message' => 'Sect status updated successfully.'
        ]);
    }
}
